∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘

> {-# LANGUAGE UnicodeSyntax #-}
> import qualified Prelude (return, undefined)

∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘


Просто типизированное лямбда-исчисление
========================================


Основы лямбда-исчисления
-------------------------

Будем называть запись лямбда-терма _подробной_, если в ней стоят
скобки (ровно одни) вокруг всех аппликаций и абстракций (а вокруг
переменных — не стоят). Иначе говоря, это строчки, построенные индуктивно
по этим трем правилам:

  * Переменная: x.
  * Абстракция: (\x -> M), где x — переменная, а M — подробная запись терма.
  * Аппликация: (M N), где M и N — подробные записи термов.

Например, запись

  (\x -> (\y -> ((x y) x))) — подробная,

а запись

  (\x -> (\y -> (x y x))) — нет, поскольку в ней есть аппликация без скобок.


◊0.1 Запишите этот терм подробно:

       \x y z -> z (y x) x

|> term01 = (??)

◊0.2 Запишите этот терм подробно:

       \f -> f (\z -> \x -> z f x) (f z)

|> term02 = (??)


◊0.3 Запишите этот терм подробно:

       (\x -> x) ((\z -> z) (\f x -> f x (f x)))

|> term03 = (??)



◊0.4 Удалите все лишние скобки:

       (\x -> (\x -> x) (\y -> y) x) ((f (\x y -> x)) z)

|> term04 = (??)

◊0.5 Выполните в term04 _один шаг_ β-редукции всеми возможными способами
     и запишите результаты, не используя лишних скобок.

|> reduced05_1 = (??)
|> reduced05_2 = (??)
...

◊0.6 Приведите term04 к нормальной форме и запишите результаты, не используя
     лишних скобок.

|> termNf06 = (??)



Типы
-----

◊1.1 Придумайте какие-нибудь термы, имеющие следующие типы:

> term11a :: a -> b -> c -> a
> term11a = (??)
>
> term11b :: a -> b -> c -> b
> term11b = (??)
>
> term11c :: a -> a -> a -> a
> term11c = (??)


◊1.2 Придумайте какие-нибудь термы, имеющие следующие типы:

> term12a :: (d -> d -> a) -> (a -> b -> c) -> (d -> b) -> d -> c
> term12a = (??)
>
> term12b :: (d -> d -> b) -> (a -> b -> c) -> (d -> b) -> d -> b
> term12b = (??)


◊1.3★★ Придумайте какие-нибудь термы, имеющие следующие типы:

> term13a :: ((a -> b) -> a) -> (a -> a -> b) -> a
> term13a = (??)
>
> term13b :: ((a -> b) -> a) -> (a -> a -> b) -> b
> term13b = (??)


◊1.4★ Сконструируйте терм, имеющий тип, `(a -> b) -> ((a -> b) -> b) -> b`,
      но которому нельзя приписать тип `a -> (a -> b) -> b`:

> term14 :: (a -> b) -> ((a -> b) -> b) -> b
> term14 = (??)


◊1.5★★ Найдите ещё два терма, имеющие данный тип, и неэквивалентные другу другу
       и тому, который вы нашли в задаче 1.3a:

> term15a :: ((a -> b) -> a) -> (a -> a -> b) -> a
> term15a = (??)
>
> term15b :: ((a -> b) -> a) -> (a -> a -> b) -> a
> term15b = (??)


◊1.6★★ Найдите терм, имеющий данный тип:

> term16 :: ((a -> b) -> a) -> a
> term16 = (??)


◊1.7★★★ Найдите терм, имеющий данный тип:

> term17 :: ((((a -> b) -> a) -> a) -> b) -> b
> term17 = (??)


◊2.1 Выведите тип терма:

> term21 :: (??)
> term21 = (\a b -> a b) (\x y -> x)

◊2.2 Выведите тип терма:

> term22 :: (??)
> term22 = (\a b -> b a a) (\x -> x)

◊2.3 Выведите тип терма:

> term23 :: (??)
> term23 = \f g x -> g (f (g (f x)))

◊2.4★ Выведите тип терма:

> term24 :: (??)
> term24 = (\f g h x -> f (h g x) (g x) x) (\x y -> y)

◊2.5★ Выведите тип терма:

> term25 :: (??)
> term25 = (\a b -> b a) (\a b -> b a)

◊2.6★★ Выведите тип терма:

> term26 :: (??)
> term26 = \x f g h -> g (g (f x)) h h

◊2.7★ Выведите тип терма:

> term27 :: (??)
> term27 = (\a b c d -> c d (a c b))


----------------------------------- ~fin~ -----------------------------------



\begin{code}
  (??){- Вместо этих вопросиков ничего писать не надо, их, очевидно, надо оставить на месте -} = Prelude.undefined
  main = Prelude.return ()
\end{code}
